package com.cool.hot100.backtracking;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/09/14:39
 * DayNumber 2
 * Hard 2
 * Level ?
 */
public class Num46 {


    List<List<Integer>> resList = new ArrayList<>();
    List<Integer> list = new ArrayList<>();

    public List<List<Integer>> permute(int[] nums) {
        for (int num : nums) {
            list.add(num);
        }
        dfs(0);
        return resList;
    }

    private void dfs(int x) {
        if (x == list.size() - 1) {
            resList.add(new ArrayList<>(list));
            return;
        }
        for (int i = x; i < list.size(); i++) {
            swap(i, x);
            dfs(x + 1);
            swap(i, x);
        }
    }

    private void swap(int x, int y) {
        int temp = list.get(x);
        list.set(x, list.get(y));
        list.set(y, temp);
    }

}
