package com.cool.hot100.strange_skills_cunning;

import org.junit.Test;

import java.util.Arrays;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/30/20:10
 * @Description: 31. 下一个排列
 * Level 5
 * Hard 2
 * DayNumber 3
 * @link https://leetcode.cn/problems/next-permutation/description/?envType=study-plan-v2&envId=top-100-liked
 */
public class Num31 {

    public void nextPermutation(int[] nums) {
        int m = 0, n = 0;
        for (int i = nums.length - 2; i >= 0; i--) {
            if (nums[i] < nums[i + 1]) {
                m = i;
                break;
            }
            if (i == 0) {
                reverse(nums, 0, nums.length);
                return;

            }
        }
        for (int i = nums.length - 1; i >= 0; i--) {
            if (nums[i] > nums[m]) {
                swap(nums, i, m);
                reverse(nums, m + 1, nums.length);
                return;
            }
        }
    }

    public void swap(int[] nums, int i, int j) {
        int temp = nums[i];
        nums[i] = nums[j];
        nums[j] = temp;
    }

    private void reverse(int[] nums, int left, int right) {
        right--;
        while (left < right) {
            swap(nums, left++, right--);
        }
    }
    @Test
    public void test(){
        nextPermutation(new int[]{3,1,2});
    }
}
