package com.cool.hot100.substring;

import org.junit.Test;

import java.util.*;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/06/13:57
 * DayNumber 1
 * Hard 3
 * Level 6
 */
public class Num79 {

    public String minWindow(String s, String t) {
        if (s.length() < t.length()) {
            return "";
        }
        int minLeft = 0;
        int minRight = Integer.MAX_VALUE;
        int left = 0;
        int right = 0;
        char[] charArray = s.toCharArray();
        Map<Character, Integer> tMap = new HashMap<>();
        Map<Character, Integer> sMap = new HashMap<>();
        for (int i = 0; i < t.length(); i++) {
            tMap.put(t.charAt(i), tMap.getOrDefault(t.charAt(i), 0) + 1);
        }
        for (int i = 0; i < charArray.length; i++) {
            if (tMap.containsKey(charArray[i])) {
                sMap.put(charArray[i], sMap.getOrDefault(charArray[i], 0) + 1);
                if (tMap.get(charArray[i]) <= sMap.get(charArray[i]) && check(sMap, tMap)) {
                    while (!tMap.containsKey(charArray[left]) || sMap.getOrDefault(charArray[left], Integer.MAX_VALUE) > tMap.get(charArray[left])) {
                        if (tMap.containsKey(charArray[left])) {
                            sMap.put(charArray[left], sMap.get(charArray[left]) - 1);
                        }
                        left++;
                    }
                    if (right - left < minRight - minLeft) {
                        minLeft = left;
                        minRight = right + 1;
                    }
                }
            }
            right++;
        }
        if (minRight == Integer.MAX_VALUE) {
            minLeft = left;
            minRight = 0;
        }
        return s.substring(minLeft, minRight);
    }

    private boolean check(Map<Character, Integer> sMap, Map<Character, Integer> tMap) {
        for (Map.Entry<Character, Integer> next : tMap.entrySet()) {
            if (!sMap.containsKey(next.getKey()) || sMap.get(next.getKey()) < next.getValue()) {
                return false;
            }
        }
        return true;
    }

    @Test
    public void test() {
        System.out.println(minWindow("aa", "aa"));
    }

}
